import { PublicAddress } from './PublicAddress';
export declare type FioFeeRatio = {
    end_point: string;
    value: number;
};
export declare const FioAddPubAddressActionAccount = "fio.address";
export declare const FioAddPubAddressActionName = "addaddress";
export declare type FioAddPubAddressActionData = {
    fio_address: string;
    public_addresses: Array<PublicAddress>;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioBurnExpiredActionAccount = "fio.address";
export declare const FioBurnExpiredActionName = "burnexpired";
export declare type FioBurnExpiredActionData = {};
export declare const FioClaimBPRewardsActionAccount = "fio.treasury";
export declare const FioClaimBPRewardsActionName = "bpclaim";
export declare type FioClaimBPRewardsActionData = {
    fio_address: string;
    actor?: string;
};
export declare const FioNewFundsRequestActionAccount = "fio.reqopt";
export declare const FioNewFundsRequestActionName = "newfundsreq";
export declare type FioNewFundsRequestActionData = {
    payer_fio_address: string;
    payee_fio_address: string;
    content: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioPayTpidRewardsActionAccount = "fio.treasury";
export declare const FioPayTpidRewardsActionName = "tpidclaim";
export declare type FioPayTpidRewardsActionData = {
    actor?: string;
};
export declare const FioProxyVoteActionAccount = "eosio";
export declare const FioProxyVoteActionName = "voteproxy";
export declare type FioProxyVoteActionData = {
    proxy: string;
    fio_address: string;
    actor?: string;
    max_fee?: number;
};
export declare const FioRecordObtDataActionAccount = "fio.reqopt";
export declare const FioRecordObtDataActionName = "recordobt";
export declare type FioRecordObtDataActionData = {
    payee_fio_address: string;
    content: string;
    fio_request_id: number;
    max_fee: number;
    tpid: string;
    actor: string;
};
export declare const FioRegisterFioAddressActionAccount = "fio.address";
export declare const FioRegisterFioAddressActionName = "regaddress";
export declare type FioRegisterFioAddressActionData = {
    fio_address: string;
    owner_fio_public_key: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioRegisterFioDomainActionAccount = "fio.address";
export declare const FioRegisterFioDomainActionName = "regdomain";
export declare type FioRegisterFioDomainActionData = {
    fio_domain: string;
    owner_fio_public_key: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioRegisterProducerActionAccount = "eosio";
export declare const FioRegisterProducerActionName = "regproducer";
export declare type FioRegisterProducerActionData = {
    fio_address: string;
    fio_pub_key: string;
    url: string;
    location: number;
    actor?: string;
    max_fee?: number;
};
export declare const FioRegisterProxyActionAccount = "eosio";
export declare const FioRegisterProxyActionName = "regproxy";
export declare type FioRegisterProxyActionData = {
    fio_address: string;
    actor?: string;
    max_fee?: number;
};
export declare const FioRejectFundsRequestActionAccount = "fio.reqobt";
export declare const FioRejectFundsRequestActionName = "rejectfndreq";
export declare type FioRejectFundsRequestActionData = {
    fio_request_id: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioRenewFioAddressActionAccount = "fio.address";
export declare const FioRenewFioAddressActionName = "renewaddress";
export declare type FioRenewFioAddressActionData = {
    fio_address: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioRenewFioDomainActionAccount = "fio.address";
export declare const FioRenewFioDomainActionName = "renewdomain";
export declare type FioRenewFioDomainActionData = {
    fio_address: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioSetFioDomainPublicActionAccount = "fio.address";
export declare const FioSetFioDomainPublicActionName = "setdomainpub";
export declare type FioSetFioDomainPublicActionData = {
    fio_domain: string;
    is_public: number;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioSubmitBundledTransactionActionAccount = "fio.fee";
export declare const FioSubmitBundledTransactionActionName = "bundlevote";
export declare type FioSubmitBundledTransactionActionData = {
    bundled_transactions: number;
    actor?: string;
};
export declare const FioSubmitFeeMultiplierActionAccount = "fio.fee";
export declare const FioSubmitFeeMultiplierActionName = "setfeemult";
export declare type FioSubmitFeeMultiplierActionData = {
    multiplier: number;
    actor?: string;
};
export declare const FioSubmitFeeRatiosActionAccount = "fio.fee";
export declare const FioSubmitFeeRatiosActionName = "setfeevote";
export declare type FioSubmitFeeRatiosActionData = {
    fee_ratios: Array<FioFeeRatio>;
    actor?: string;
};
export declare const FioTransferTokensPubKeyActionAccount = "fio.token";
export declare const FioTransferTokensPubKeyActionName = "trnsfiopubky";
export declare type FioTransferTokensPubKeyActionData = {
    payee_public_key: string;
    amount: string;
    max_fee?: number;
    tpid?: string;
    actor?: string;
};
export declare const FioUnregisterProducerActionAccount = "eosio";
export declare const FioUnregisterProducerActionName = "unregprod";
export declare type FioUnregisterProducerActionData = {
    fio_address: string;
    actor?: string;
    max_fee?: number;
};
export declare const FioUnregisterProxyActionAccount = "eosio";
export declare const FioUnregisterProxyActionName = "unregproxy";
export declare type FioUnregisterProxyActionData = {
    fio_address: string;
    actor?: string;
    max_fee?: number;
};
export declare const FioVoteProducerActionAccount = "eosio";
export declare const FioVoteProducerActionName = "voteproducer";
export declare type FioVoteProducerActionData = {
    producers: Array<String>;
    fio_address: string;
    actor?: string;
    max_fee?: number;
};
export declare type FioActionAccount = 'fio.address' | 'fio.reqobt' | 'fio.token' | 'eosio';
export declare type FioActionName = 'addaddress' | 'burnexpired' | 'bpclaim' | 'newfundsreq' | 'tpidclaim' | 'voteproxy' | 'recordobt' | 'regaddress' | 'regdomain' | 'regproducer' | 'regproxy' | 'rejectfndreq' | 'renewaddress' | 'renewdomain' | 'setdomainpub' | 'bundlevote' | 'setfeemult' | 'setfeevote' | 'trnsfiopubky' | 'unregprod' | 'unregproxy' | 'voteproducer';
export declare type FioActionData = FioAddPubAddressActionData | FioBurnExpiredActionData | FioClaimBPRewardsActionData | FioNewFundsRequestActionData | FioPayTpidRewardsActionData | FioProxyVoteActionData | FioRecordObtDataActionData | FioRegisterFioAddressActionData | FioRegisterFioDomainActionData | FioRegisterProducerActionData | FioRegisterProxyActionData | FioRejectFundsRequestActionData | FioRenewFioAddressActionData | FioRenewFioDomainActionData | FioSetFioDomainPublicActionData | FioSubmitBundledTransactionActionData | FioSubmitFeeMultiplierActionData | FioSubmitFeeRatiosActionData | FioTransferTokensPubKeyActionData | FioUnregisterProducerActionData | FioUnregisterProxyActionData | FioVoteProducerActionData;
